#include "libgccvb.h"
#include "titlescreenchar.h"
#include "titlescreenmap.h"
#include "lhfont.h"
#include "scene1char.h"
#include "scene1map.h"
#include "scene2char.h"
#include "scene2map.h"
#include "pinkspritesmap.h"
#include "pinkspriteschar.h"
#include "screen1map.h"
#include "mountainchar.h"
#include "swordgettingscreenmap.h"
#include "swordgettingscreenchar.h"

int pinkx=180, pinky=120, pinkfacingdir=0, movingtimer=0, ud=0, lr=1, pinkwalktimer=0, up=0, down=0, left=0, right=0;
int screen=1, sword=0;

HWORD getBGMapChar(bgmap, x, y)
    	{ 
     	return (BGMM[(0x1000) + (y * 64) + x]&0x7FF);  
    	} 




int main () {
	unsigned char selpad=0; 	// This value is only needed in the main loop, so I moved it to the main loop.
					// And it doesn't need to be very big, so I made it a char.  an int takes up a lot
					// more space than a char (char is 8 bits, short is 16 bits, long and int are 32)
					// putting unsigned means the value will go between 0 and 255, rather than -128 to 127

	copymem ((void*)CharSeg3, (void*)LHFONT, 8192);
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);

	vbDisplayOn();
	vbDisplayShow();

        vbTextOut(0, 19, 11,"IMPORTANT:");
        vbTextOut(0, 14, 12,"READ INSTRUCTION AND");
        vbTextOut(0, 14, 13,"PRECAUTION  BOOKLETS");
        vbTextOut(0, 16, 14,"BEFORE OPERATING");

	while(!(vbReadPad()&K_ANY)){}
	while(vbReadPad()&K_ANY){}

	vbFXFadeOut(1);
	
	vbSetWorld(31, WRLD_ON, 46, 0, 40, 0, 0, 0, 384, 224);

	copymem((void*)CharSeg0, (void*)TITLESCREENCHAR, 256*16);
	copymem((void*)BGMap(0), (void*)TITLESCREENMAP, 256*16);
	vbTextOut(0, 5, 17,"/2013 AEGIS GAMES");
	vbTextOut(0, 5, 19, "-NEW GAME");	
	vbTextOut(0, 6, 20, "LOAD GAME");	

	vbDisplayOn(); 
	vbDisplayShow();
	
	while(!(vbReadPad()&K_STA)){
		
		if(vbReadPad()&K_SEL) {
			selpad=selpad+1;
			if (selpad>1) selpad=0;
			
			if (selpad==0) {
				vbTextOut(0, 5, 19, "-");
				vbTextOut(0, 5, 20, " ");
			} else {		
				vbTextOut(0, 5, 19, " ");
				vbTextOut(0, 5, 20, "-");
			}	
			while(vbReadPad()&K_SEL){} 
		}	
	}
	while(vbReadPad()&K_STA){}
	
	vbFXFadeOut(1);
	
	if((vbReadPad()&K_STA) && (selpad==1)) {
		loadGame();// Go to the Load Game routine, which, in this case, is an infinite loop of nothing.
	} else {
		startNewGame();
	}
	// Now your game data is initalized (either a new game was made or old data was loaded)
	// You should make another function call, maybe inside a loop,, I dont know
	// The idea is to keep the main() function clean and make a bunch of function calls.
	
	while(1) {}
}

int loadGame() {
	// This is where your load game code will go.  for now, it just returns without doing anything.
}

int startNewGame() {
	// This is where your start new game code will go.
	// Doing it this way assumes you will have basic setup stuff that you would normally not have
	// No actual game play should go in here
	// After this stuff is done, it will go back to after the if statement in the main() function
	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	copymem((void*)CharSeg1, (void*)SCENE1CHAR, 256*16);
	copymem((void*)BGMap(1), (void*)SCENE1MAP, 256*16);
	
	vbTextOut(1, 1, 16,"OUR STORY BEGINS WHEN PRINCESS HELGA");
	vbTextOut(1, 1, 17,"COMES DOWN WITH AN AWFUL CASE OF TOENAIL");
	vbTextOut(1, 1, 18,"FUNGUS. MAN, IT LOOKS PRETTY BAD.");
	vbTextOut(1, 1, 19,"                                   ");
	vbTextOut(1, 1, 20,"                                   ");
	
	vbDisplayOn(); 
	vbDisplayShow();


	while(!(vbReadPad()&K_A)){}
	while(vbReadPad()&K_A){}	

	
	vbFXFadeOut(1);
	
	vbSetWorld(31, WRLD_ON|1, 26, 0, 0, 0, 0, 0, 384, 224);
	copymem((void*)CharSeg1, (void*)SCENE2CHAR, 256*16);
	copymem((void*)BGMap(1), (void*)SCENE2MAP, 256*16);
	
	vbTextOut(1, 2, 16,"HELGA SENT OUT FOR HER PAIGE, NAMED");
	vbTextOut(1, 3, 17,"PINK, TO TRY AND FIND A CURE FOR");
	vbTextOut(1, 2, 18,"HER AWFUL DILEMMA. CAN PINK SURVIVE");
	vbTextOut(1, 3, 19,"ALL FATE HAS IN STORE FOR HIM AND");
	vbTextOut(1, 2, 20,"WIN THE PRINCESS'S HEART AS WELL AS");
	vbTextOut(1, 4, 21,"DEFEAT THE ICKY TOENAIL FUNGUS?");


	vbFXFadeIn(1);

	
	while(!(vbReadPad()&K_A)){}
	while(vbReadPad()&K_A){}
	
	vbFXFadeOut(1);
	
	main2();
	
	
	}
	
int main2()
	{
	
	
	vbTextOut(3, 11, 7,"                           ");
	vbTextOut(3, 11, 8,"                           ");	
	
	copymem((void*)CharSeg2, (void*)PINKSPRITESCHAR, 256*16);
	copymem((void*)BGMap(2), (void*)PINKSPRITESMAP, 256*16);	
	
	copymem((void*)CharSeg1, (void*)MOUNTAINCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)SCREEN1MAP, 256*16);	
	
	if (sword==1) vbSetWorld(29, WRLD_ON|2, pinkx, 0, pinky+2, 0, 16, 16, 8, 8);
	vbSetWorld(30, WRLD_ON|2, pinkx, 0, pinky, pinkfacingdir, 0, 0, 16, 15);	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);		
	
	
	vbFXFadeIn(1);
	



	while(1)
	{	
	if (sword==1) vbSetWorld(29, WRLD_ON|2, pinkx, 0, pinky+2, 0, 16, 16, 8, 8);
	vbSetWorld(30, WRLD_ON|2, pinkx, 0, pinky, pinkfacingdir, 0, 0, 16, 15);	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);	
	
	if(!(vbReadPad()&K_LL) && (!(vbReadPad()&K_LR)) && (lr==1)) pinkfacingdir=96;	
	

	if((vbReadPad()&K_LL) && (!(vbReadPad()&K_LU)) && (!(vbReadPad()&K_LD))) ud=0, up=0, down=0, left=1, right=0, lr=1, pinkx--, movingtimer++;	
	if((vbReadPad()&K_LL) && (lr==1) && (!(getBGMapChar(1, (pinkx/8)-0, (pinky/8)-0)==512)) && (!(getBGMapChar(1, (pinkx/8)+0, (pinky/8)+0)==512))  && (movingtimer>10))  pinkwalktimer++;
	if((vbReadPad()&K_LL) && (lr==1) && (getBGMapChar(1, (pinkx/8)+0, (pinky/8)+1)==512)) pinkx=pinkx+2, lr=0, movingtimer=0;	
	//if((vbReadPad()&K_LL) && (lr==1) && (getBGMapChar(1, (pinkx/8)+0, (pinky/8)+0)==512)) pinkx=pinkx+2, lr=0, movingtimer=0;
	if ((left==1) && (pinkfacingdir<144)) pinkwalktimer=0, pinkfacingdir=144;		
	if ((left==1) && (pinkwalktimer>10) && (pinkfacingdir==144)) pinkwalktimer=0, pinkfacingdir=160, movingtimer=0;
	if ((left==1) && (pinkwalktimer>10) && (pinkfacingdir==160)) pinkwalktimer=0, pinkfacingdir=144, movingtimer=0;
	

	if((vbReadPad()&K_LR) && (!(vbReadPad()&K_LU))  && (!(vbReadPad()&K_LD)))  ud=0, up=0, down=0, left=0, right=1, lr=1, pinkx++, movingtimer++;
	if((vbReadPad()&K_LR) && (lr==1) && (!(getBGMapChar(1, (pinkx/8)+2, (pinky/8)-0)==512)) && (!(getBGMapChar(1, (pinkx/8)+0, (pinky/8)+0)==512))  && (movingtimer>10)) pinkwalktimer++;
	if((vbReadPad()&K_LR) && (lr==1) && (getBGMapChar(1, (pinkx/8)+2, (pinky/8)+1)==512)) pinkx=pinkx-2, lr=0, movingtimer=0;	
	//if((vbReadPad()&K_LR) && (lr==1) && (getBGMapChar(1, (pinkx/8)+2, (pinky/8)+0)==512)) pinkx=pinkx-2, lr=0, movingtimer=0;		
	if ((right==1) && (pinkfacingdir<112)) pinkwalktimer=0, pinkfacingdir=112;	
	if ((right==1) && (pinkfacingdir>128)) pinkwalktimer=0, pinkfacingdir=112;		
	if ((right==1) && (pinkwalktimer>10) && (pinkfacingdir==112)) pinkwalktimer=0, pinkfacingdir=128, movingtimer=0;
	if ((right==1) && (pinkwalktimer>10) && (pinkfacingdir==128)) pinkwalktimer=0, pinkfacingdir=112, movingtimer=0;	
	
	
	if(!(vbReadPad()&K_LU) && (up==1)) pinkfacingdir=64;		
	if((vbReadPad()&K_LU) && (!(vbReadPad()&K_LR))  && (!(vbReadPad()&K_LL))) lr=0, ud=1, left=0, right=0, up=1, down=0, pinky--, movingtimer++;
	if((vbReadPad()&K_LU) && (ud==1) && (!(getBGMapChar(1, (pinkx/8)+0, (pinky/8)+0)==512)) && (!(getBGMapChar(1, (pinkx/8)+2, (pinky/8)+2)==512)) && (movingtimer>10))  up=1, down=0, pinkwalktimer++;		
	if((vbReadPad()&K_LU) && (ud==1) && (getBGMapChar(1, (pinkx/8)+0, (pinky/8)+0)==512)) pinky=pinky+2, ud=0, movingtimer=0;
	if((vbReadPad()&K_LU) && (ud==1) && (getBGMapChar(1, (pinkx/8)+2, (pinky/8)+0)==512)) pinky=pinky+2, ud=0, movingtimer=0;
	if ((up==1) && (pinkfacingdir<48)) pinkwalktimer=0, pinkfacingdir=64;
	if ((up==1) && (pinkfacingdir>80)) pinkwalktimer=0, pinkfacingdir=64;
	if ((up==1) && (pinkwalktimer>10) && (pinkfacingdir==64)) pinkwalktimer=0, pinkfacingdir=80, movingtimer=0;
	if ((up==1) && (pinkwalktimer>10) && (pinkfacingdir==80)) pinkwalktimer=0, pinkfacingdir=64, movingtimer=0;		
	
	if(!(vbReadPad()&K_LD) && (down==1)) pinkfacingdir=0;		
	if((vbReadPad()&K_LD) && (!(vbReadPad()&K_LR))  && (!(vbReadPad()&K_LL))) lr=0, left=0, right=0, ud=1, up=0, down=1, pinky++, movingtimer++;
	if((vbReadPad()&K_LD) && (ud==1) && (!(getBGMapChar(1, (pinkx/8)+0, (pinky/8)+2)==512)) && (!(getBGMapChar(1, (pinkx/8)+2, (pinky/8)+2)==512)) &&(movingtimer>10))  up=0, down=1, pinkwalktimer++;		
	if((vbReadPad()&K_LD) && (ud==1) && (getBGMapChar(1, (pinkx/8)+0, (pinky/8)+2)==512)) pinky=pinky-2, ud=0, movingtimer=0;
	if((vbReadPad()&K_LD) && (ud==1) && (getBGMapChar(1, (pinkx/8)+2, (pinky/8)+2)==512)) pinky=pinky-2, ud=0, movingtimer=0;
	if ((down==1) && (pinkfacingdir>32)) pinkwalktimer=0, pinkfacingdir=16;
	if ((down==1) && (pinkwalktimer>10) && (pinkfacingdir==16)) pinkwalktimer=0, pinkfacingdir=32, movingtimer=0;
	if ((down==1) && (pinkwalktimer>10) && (pinkfacingdir==32)) pinkwalktimer=0, pinkfacingdir=16, movingtimer=0;


	if ((pinkx>15) && (pinkx<33) && (pinky<48) && (screen==1)) getsword();

	//vbSetWorld(27, WRLD_ON|3, enemyx, 0, enemyy, 0, 0, 0, 72, 16);	
	
	
	}
	
		}
int getsword()
	{
	copymem ((void*)CharSeg3, (void*)LHFONT, 8192);

	
	copymem((void*)CharSeg1, (void*)SWORDGETTINGSCREENCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)SWORDGETTINGSCREENMAP, 256*16);	
	
	while(1){
	pinkx=180, pinky=200;
	

	

	vbSetWorld(30, WRLD_ON|2, pinkx, 0, pinky, pinkfacingdir, 0, 0, 16, 16);	
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);	

	if (vbReadPad()&K_LD) pinkx=24, pinky=50, sword=1, main2();
	if (sword==1) vbSetWorld(29, WRLD_ON|2, pinkx, 0, pinky+2, 0, 16, 16, 8, 8);

	if (sword==0) vbTextOut(1, 11, 7,"IT'S DANGEROUS TO GO ALONE.");
	if (sword==0) vbTextOut(1, 11, 8,"     HERE. TAKE THIS.      ");
	
	if (sword==1) vbTextOut(1, 11, 7,"   YOU AGAIN? I GAVE YOU A   ");
	if (sword==1) vbTextOut(1, 11, 8,"SWORD. WHAT ELSE DO YOU WANT?");	
	}
	}
